require("babel-polyfill");
var Mapache = require('./src/models/mapache.js');

window.Mapache = new Mapache();

var prefix = "", _addEventListener, _removeEventListener, support;

// detecta el tipo de evento permitido por el navegador
if ( window.addEventListener ) {
    _addEventListener = "addEventListener";
    _removeEventListener = "removeEventListener";
} else {
    _addEventListener = "attachEvent";
    _removeEventListener = "detachEvent";
    prefix = "on";
}

support = "onwheel" in document.createElement("div") ? "wheel" :
          document.onmousewheel !== undefined ? "mousewheel" :
          "DOMMouseScroll";

window.Mapache.addWheelListener = function( elem, callback, useCapture ) {
    _addWheelListener( elem, support, callback, useCapture );

    if( support == "DOMMouseScroll" ) {
        _addWheelListener( elem, "MozMousePixelScroll", callback, useCapture );
    }
};

window.Mapache.removeWheelListener = function( elem, callback, useCapture ) {
    _removeWheelListener( elem, support, callback, useCapture );

    if( support == "DOMMouseScroll" ) {
        _removeWheelListener( elem, "MozMousePixelScroll", callback, useCapture );
    }
}

function _addWheelListener( elem, eventName, callback, useCapture ) {
    elem[ _addEventListener ]( prefix + eventName, support == "wheel" ? callback : function( originalEvent ) {
        !originalEvent && ( originalEvent = window.event );

        var event = {
            originalEvent: originalEvent,
            target: originalEvent.target || originalEvent.srcElement,
            type: "wheel",
            deltaMode: originalEvent.type == "MozMousePixelScroll" ? 0 : 1,
            deltaX: 0,
            deltaZ: 0,
            preventDefault: function() {
                originalEvent.preventDefault ?
                    originalEvent.preventDefault() :
                    originalEvent.returnValue = false;
            }
        };

        if ( support == "mousewheel" ) {
            event.deltaY = - 1/40 * originalEvent.wheelDelta;
            originalEvent.wheelDeltaX && ( event.deltaX = - 1/40 * originalEvent.wheelDeltaX );
        } else {
            event.deltaY = originalEvent.detail;
        }

        // Disparamos el callback
        return callback( event );

    }, useCapture || false );
}

function _removeWheelListener( elem, eventName, callback, useCapture ) {
    elem[ _removeEventListener ]( prefix + eventName, callback, useCapture || false );
}

window.onclick = function(event) {
    if (!event.target.matches('.mp-dropdown-btn')) {
        let dropdowns = document.getElementsByClassName('mp-dropdown');
        let i;

        for (i = 0; i < dropdowns.length; i++) {
            let openDropdown = dropdowns[i];
            if (openDropdown.classList.contains('show-dropdown')) {
                openDropdown.classList.remove('show-dropdown');
            }
        }
    }
}
