"use strict"

var NodeComponent = require('./mp-node-component.js');

// @abstract class Decorator
//
// Abstract class that has all the basic methods that a Node component needs
// and a reference to the previous component.
class Decorator extends NodeComponent {
    constructor(component, node) {
        super(node);

        if(this.render === undefined) {
            throw new TypeError('render method must be defined in class');
        }
        if(this.update === undefined) {
            throw new TypeError('update method must be defined in class');
        }
        if(this.remove === undefined) {
            throw new TypeError('remove method must be defined in class');
        }
        if(this.hasComp === undefined) {
            throw new TypeError('hasComp method must be defined in class');
        }

        this._component = component;
    }

    render() {
        this.render();
    }

    update() {
        this.update();
    }

    remove() {
        this.remove();
    }
}

module.exports = Decorator;
