"use strict"

// @abstract NodeComponent
//
// Abstract class that has all the basic methods that a Node component needs
// and a reference to the node itself.
class NodeComponent {
    constructor(node) {
        if(new.target === NodeComponent) {
            throw new TypeError('Cannot construct interface instances');
        }
        if(this.render === undefined) {
            throw new TypeError('render method must be defined in class');
        }
        if(this.update === undefined) {
            throw new TypeError('update method must be defined in class');
        }
        if(this.remove === undefined) {
            throw new TypeError('remove method must be defined in class');
        }
        if(this.hasComp === undefined) {
            throw new TypeError('hasComp method must be defined in class');
        }

        this._node = node;
    }
}

module.exports = NodeComponent;
