"use strict"

module.exports = {
    flatten(arr) {
        return Array.prototype.concat.apply([], arr);
    },

    intersection(a1, a2, eq) {
        return a1.filter(e1 => a2.some(e2 => eq(e1, e2)));
    },

    outerIntersection(a1, a2, eq) {
        return a1.filter(e1 => !a2.some(e2 => eq(e1, e2)));
    },

    takeWhile(arr, f) {
        let ok = true;
        return arr.filter(e => ok && (ok = f(e)));
    },

    removeFrom(arr, attr, val) {
        let a = arr.map(a1 => a1[attr]);
        let i = a.indexOf(val);

        if(i >= 0) {
            arr.splice(i, 1);
        }
    },

    unique(arr, f) {
        const vArr = arr.map(f);
        return arr.filter((_, i) => vArr.indexOf(vArr[i]) === i);
    }
}
