"use strict"

module.exports = {
    createMapLayer(map, tileURL) {
        if(map._mapConfig._crs === 'outdoor') {
            return L.layerGroup([
                L.tileLayer(tileURL, {
                    attribution: 'Map data &copy; <a href="http://openstreetmap.org">OpenStreetMap</a> contributors, <a href="http://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>',
                    maxZoom: 18
                })
            ]);
        }
        else {
            const southWest = map._map.unproject([0, map._mapConfig._height], map._map.getMaxZoom());
            const northEast = map._map.unproject([map._mapConfig._width, 0], map._map.getMaxZoom());
            const bounds = L.latLngBounds(southWest, northEast);

            return L.layerGroup([
                L.tileLayer(tileURL, { noWrap: true, bounds: bounds })
            ]);
        }
    },

    getPosition(map, position) {
        if(map._mapConfig._crs === 'outdoor') {
            return position
        }
        else {
            return map._map.unproject(
                [
                    map._mapConfig._height * position[0],
                    map._mapConfig._width * position[1]
                ],
                map._map.getMaxZoom()
            );
        }
    }
}
