"use strict"

module.exports = {
    createElement(attrs) {
        let el = document.createElement(attrs.type);
        if(attrs.id !== undefined) { el.id = attrs.id; }
        if(attrs.class !== undefined) { el.className = attrs.class; }
        if(attrs.innerHTML !== undefined) { el.innerHTML = attrs.innerHTML; }

        return el;
    },

    createSVG(attrs) {
        let el = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        el.setAttribute('width', attrs.width);
        el.setAttribute('height', attrs.height);

        let circle = document.createElementNS('http://www.w3.org/2000/svg', 'circle');
        circle.setAttribute('cx', attrs.height / 2);
        circle.setAttribute('cy', attrs.width / 2);
        circle.setAttribute('r', attrs.width / 2 - 1);

        el.appendChild(circle);

        return el;
    },

    addClass(element, className) {
        let elementClassName = element.className;
        elementClassName = elementClassName.replace(` ${className}`, '');
        elementClassName += ` ${className}`;
        element.className = elementClassName;
    },

    removeClass(element, className) {
        let elementClassName = element.className;
        elementClassName = elementClassName.replace(` ${className}`, '');
        element.className = elementClassName;
    },

    toggleClass(element, className) {
        let elementClassName = element.className;
        if((' ' + elementClassName + ' ').indexOf(' ' + className + ' ') > -1) {
            elementClassName = elementClassName.replace(` ${className}`, '');
        }
        else {
            elementClassName += ` ${className}`;
        }
        element.className = elementClassName;
    }
}
